Qore Programming Language Reference Manual 0.8.8

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Groups Pages
Public Member Functions | List of all members
<int> Class Reference

Methods in this pseudo-class can be executed on integer values. More...

Inheritance diagram for Qore::<int>:
[legend]

## Public Member Functions
int | abs ()
| Returns the absolute value of the number. More...
binary | encodeLsb (int size=4)
| returns a binary object with the integer encoded in the given number of bytes in least significant byte order More...
binary | encodeMsb (int size=4)
| returns a binary object with the integer encoded in the given number of bytes in most significant byte order More...
string | format (string fmt)
| Returns a string of a formatted number according to a format string. More...
bool | intp ()
| Returns True by default. More...
int | sign ()
| Returns -1 if the number is negative, 0 if it is zero, or 1 if it is positive. More...
bool | strp ()
| Returns True because integer values can be converted to strings. More...
string | toUnicode ()
| Returns a single character string in UTF-8 encoding for the integer value treated as a unicode value. More...
int | typeCode ()
| Returns Qore::NT_INT. More...
bool | val ()
| Returns True if the int is non-zero, False if zero. More...
Public Member Functions inherited from <value>
bool | callp ()
| Returns False; this method is reimplemented in other types and will return True if the given expression is a callable value (ie closures or call references) More...
bool | empty ()
| Returns True; this method will be reimplemented in container types where it may return False. More...
bool | intp ()
| Returns False; this method is reimplemented in other types and will return True if the given expression can be converted to an integer. More...
AbstractIterator | iterator ()
| Returns an iterator object for the value; the default iterator object returned is SingleValueIterator. More...
int | lsize ()
| Returns 1; the return value of this method should give the list size of the value, which is normally 1 for non-lists (except for NOTHING where the size will be 0) and the number of the elements in the list for lists; this method will be reimplemented in other types where it may return other values. More...
int | size ()
| Returns zero; this method will be reimplemented in container types where it may return a non-zero value. More...
bool | strp ()
| Returns False; this method is reimplemented in other types and will return True if the given expression can be converted to a string. More...
bool | toBool ()
| Returns the boolean representation of the value; the default is False. More...
float | toFloat ()
| Returns the floating-point representation of the value; the default is 0.0. More...
int | toInt ()
| Returns the integer representation of the value; the default is 0. More...
number | toNumber ()
| Returns the arbitrary-precision numeric representation of the value; the default is 0. More...
string | toString ()
| Returns the string representation of the value; the default is an empty string. More...
string | type ()
| Returns the string type for the value. More...
int | typeCode ()
| Returns the type code for the value. More...
bool | val ()
| Returns False; this method is reimplemented in other types and will return True if the given expression has a value. More...

## Detailed Description

Methods in this pseudo-class can be executed on integer values.

## Member Function Documentation

int <int>::abs | ( |  | ) |

Returns the absolute value of the number.

Code Flags:
  CONSTANT

Example:
  $i = $i.abs();

Returns
  the absolute value of the number

Note
  equivalent to abs(int)

Since
  Qore 0.8.8

binary <int>::encodeLsb | ( | int | size = `4` | ) |

returns a binary object with the integer encoded in the given number of bytes in least significant byte order

Code Flags:
  RET_VALUE_ONLY

Example:
  $b += $i.encodeLsb(8);

Parameters

  size | the size of the encoded binary object; must be 1, 2, 4, or 8 or a SIZE-ERROR exception is raised

Returns
  a binary object with the integer encoded in the given number of bytes in least significant byte order

Exceptions

  SIZE-ERROR | the argument is not 1, 2, 4, or 8 or the argument cannot fit in the number of bytes requested

Since
  Qore 0.8.8

binary <int>::encodeMsb | ( | int | size = `4` | ) |

returns a binary object with the integer encoded in the given number of bytes in most significant byte order

Code Flags:
  RET_VALUE_ONLY

Example:
  $b += $i.encodeMsb(8);

Parameters

  size | the size of the encoded binary object; must be 1, 2, 4, or 8 or a SIZE-ERROR exception is raised

Returns
  a binary object with the integer encoded in the given number of bytes in most significant byte order

Exceptions

  SIZE-ERROR | the argument is not 1, 2, 4, or 8 or the argument cannot fit in the number of bytes requested

Since
  Qore 0.8.8

string <int>::format | ( | string | fmt | ) |

Returns a string of a formatted number according to a format string.

Code Flags:
  CONSTANT

Parameters

  fmt | the format string has the following format: <thousands_separator>`[`<decimal_separator><decimals>`]` where: thousands_separator and decimal_separator are single ASCII characters defining the thousands and decimal separator characters respectively, and decimals is a single digit defining how may decimals should appear after the decimal point - if this is non-zero then the decimals will all be `"0"`

Returns
  a string of a formatted number according to a format string; if the format string does not follow the given format, then an empty string is returned

Example:
  my int $i = -48392093894;
  my string $nstr = $i.format(".,3"); # returns "-48.392.093.894,000"

See Also
  - <float>::format(string)
  - <number>::format(string)

Since
  Qore 0.8.6

bool <int>::intp | ( |  | ) |

Returns True by default.

Returns
  True by default

Code Flags:
  CONSTANT

Example:
  if ($n.intp())
  printf("%y: can be converted to an integer: %d\n", $n, int($n));

int <int>::sign | ( |  | ) |

Returns -1 if the number is negative, 0 if it is zero, or 1 if it is positive.

Returns
  -1 if the number is negative, 0 if it is zero, or 1 if it is positive

Code Flags:
  CONSTANT

Example:
  printf("sign: %d\n", $i.sign());

Since
  Qore 0.8.6

bool <int>::strp | ( |  | ) |

Returns True because integer values can be converted to strings.

Returns
  True because integer values can be converted to strings

Code Flags:
  CONSTANT

Example:
  if ($n.strp())
  printf("%y: can be converted to a string: '%s'\n", $n, string($n));

string <int>::toUnicode | ( |  | ) |

Returns a single character string in UTF-8 encoding for the integer value treated as a unicode value.

Code Flags:
  RET_VALUE_ONLY

Example:
  my string $str = 0x00f8.toUnicode()

Returns
  a single character string in UTF-8 encoding for the integer value treated as a unicode value

Note
  only the least-significant 4 bytes of the integer are used

Since
  Qore 0.8.8

int <int>::typeCode | ( |  | ) |

Returns Qore::NT_INT.

Returns
  Qore::NT_INT

Code Flags:
  CONSTANT

Example:
  switch ($i.typeCode()) {
  case NT_INT:
  printf("%y: is a int\n", $i);
  break;
  }

bool <int>::val | ( |  | ) |

Returns True if the int is non-zero, False if zero.

Returns
  True if the int is non-zero, False if zero

Code Flags:
  CONSTANT

Example:
  my bool $b = $i.val();

See Also
  - %perl-bool-eval
  - %strict-bool-eval